/** myDatabase.java
 *
 * This class provides methods to access the Oracle database via JDBC
 * API:  void open(), void close(), executeSQL(String sql), getRecord(String sql) 
 * Exceptions are printed.
 *
 * @author xjqiu@npac.syr.edu 
 */

import java.sql.*; 
import java.util.Properties;
import java.util.*;

class myDatabase {
  
  private Connection conn = null;
  private Statement stmt = null;
  private ResultSet results = null;
  
  public boolean open() {  //Open the connection to DB

   try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
      conn = DriverManager.getConnection ("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe", "cy99xfq", "cy99xfq");
      System.out.println("myDatabase->open: Connection Open"); //print to commandline, not console
      return true;
    }
    catch (Exception ex) { 
		System.err.println("myDatabase->open: Error connection..." ); 
        ex.printStackTrace();
		return false;
    }
  }
  

  public boolean close() { //Close connection to DB
    
	try {
      conn.close();
      System.out.println("myDatabase->close: Connection Closed"); //print to commandline
	  return true; }
    catch (Exception ex) {
		System.err.println("myDatabse->close: Exception...");
        ex.printStackTrace();
		return false;
    }
  }
  

  public Vector doSearch(String sql) {

      Hashtable ht;
      Vector vec = new Vector();
  
      System.out.println("myDatabase->doSearch: sql is "+sql);

	  try {
          System.out.println("myDatabase->doSearch:  is called.");

          vec = getRecords(sql);

          if (vec.size() <= 0) {
              System.out.println("myDatabase->doSearch: No records matched.\n");
          }else {
              System.out.println("myDatabase->doSearch: There are records matched!\n");
          } 
	   }catch (Exception ex) {
             System.out.println("myDatabse->doSearch: Exception...");
             ex.printStackTrace();
       }
	   return vec;
  }



  public boolean doInsert(String sql) { //Insert new record to database file

		try {
             System.out.println("myDatabase->doInsert:  is called.");
             executeSQL(sql); //perform INSERT
		     System.out.println("myDatabase->doInsert: New record has been added to Database!");
             return true;
         }catch(Exception ex) {
             System.out.println("myDatabse->doInsert: Exception...");
             ex.printStackTrace();
             return false;
         }
   }



  public int getMaxId(String sql) { //Get the Maxium id from records returned 

      int i = 0;
      try {
      	stmt = conn.createStatement();
      	results = stmt.executeQuery(sql);
        if(results == null) return -1;
      	results.next();
      	i = results.getInt("max(id)");
      	results.close();
      	stmt.close();
      }catch(Exception ex) {
          ex.printStackTrace(System.out);
          return -1;
      }
      return i;
  }

 public int executeSQL(String sql) { // Execute Query operation by input sql string 
    int i = -1;
    try {
        stmt = conn.createStatement();
        stmt.execute(sql);
        i = 1;

        System.out.println("myDatabase->executeSQL: is performed."); 

        stmt.close();
    }catch(Exception ex) {
        System.out.println("myDatabase->executeSQL: Exception...");
        ex.printStackTrace(System.out);
    }
    return i;
 }

  public Vector getRecords(String sql) {//Return all records that matches the given name/phone field

      Vector vec = new Vector();
      Hashtable ht = new Hashtable();

   	  if (conn == null) {//connection to database hasn't open yet
		 try {
      	      Class.forName("oracle.jdbc.driver.OracleDriver");
      	      conn = DriverManager.getConnection ("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe", "cy99xfq", "cy99xfq");
      	      System.out.println("myDatabase->getRecords: Connection Open"); //print to commandline, not console
		 }catch(Exception ex) {
			  System.err.println("myDatabase->getRecords: Error connection..." ); 
        	  ex.printStackTrace();
	     }
	   }//endif


      System.out.println("myDatabase->getRecords: is performed.");
      System.out.println("myDatabase->getRecords: sql is "+ sql);

      try {
      		stmt = conn.createStatement();
      		results = stmt.executeQuery(sql);
      		while(results.next()) {
          		ht.put("id",new Integer(results.getInt("id")));
          		ht.put("course",results.getString("course"));
          		ht.put("refno",results.getString("refno"));
          		ht.put("cname",results.getString("cname"));
          		ht.put("instr",results.getString("instr"));
          		ht.put("location",results.getString("location"));
          		ht.put("day",results.getString("day"));
          		ht.put("time",results.getString("time"));
          		vec.addElement(ht.clone());
          		System.out.println("myDatabase->getRecords:  Hashtable inside getRec = "+ht);
          		ht.clear();
      		}
      		results.close();
      		stmt.close();
//          conn = null; 
      }catch(Exception ex) {
          System.out.println("myDatabase->getRecords: Exception...");
          ex.printStackTrace(System.out);
      }
      return vec;  //return matched records as hashtables in the vector
  }
  

/**
 * This method forms SQL string.
 */

  public  String getSQLstringForSearch(String courses) {

      String tmpstr, deptcoursesection,sql;
      StringBuffer strbuf;

      tmpstr = "select * from course_table where ";
      strbuf = new StringBuffer();
      deptcoursesection = courses; 

      if (deptcoursesection.trim().equals("*")) {//SQL for list all records in database file
            strbuf.append("course like '%'");
      }else { 
      		   if(!(deptcoursesection.trim().equals(""))) {//SQL for specified records
            		strbuf.append("upper(course)=upper('"+deptcoursesection.trim()+"')");
               }
      }
 
      tmpstr = tmpstr + strbuf.toString();
      return tmpstr;
  }

}//end of class

